pluginpref.h File Reference
libpurple

Plugin Preferences API. More...

`#include <glib.h>`
`#include "prefs.h"`

Go to the source code of this file.

## Typedefs

typedef struct _PurplePluginPrefFrame | PurplePluginPrefFrame
typedef struct _PurplePluginPref | PurplePluginPref

## Enumerations

enum | PurpleStringFormatType { PURPLE_STRING_FORMAT_TYPE_NONE = 0, PURPLE_STRING_FORMAT_TYPE_MULTILINE = 1 << 0, PURPLE_STRING_FORMAT_TYPE_HTML = 1 << 1 }
| String format for preferences. More...
enum | PurplePluginPrefType { PURPLE_PLUGIN_PREF_NONE, PURPLE_PLUGIN_PREF_CHOICE, PURPLE_PLUGIN_PREF_INFO, PURPLE_PLUGIN_PREF_STRING_FORMAT }

## Functions

Plugin Preference API
PurplePluginPrefFrame * | purple_plugin_pref_frame_new (void)
| Create a new plugin preference frame. More...
void | purple_plugin_pref_frame_destroy (PurplePluginPrefFrame *frame)
| Destroy a plugin preference frame. More...
void | purple_plugin_pref_frame_add (PurplePluginPrefFrame *frame, PurplePluginPref *pref)
| Adds a plugin preference to a plugin preference frame. More...
GList * | purple_plugin_pref_frame_get_prefs (PurplePluginPrefFrame *frame)
| Get the plugin preferences from a plugin preference frame. More...
PurplePluginPref * | purple_plugin_pref_new (void)
| Create a new plugin preference. More...
PurplePluginPref * | purple_plugin_pref_new_with_name (const char *name)
| Create a new plugin preference with name. More...
PurplePluginPref * | purple_plugin_pref_new_with_label (const char *label)
| Create a new plugin preference with label. More...
PurplePluginPref * | purple_plugin_pref_new_with_name_and_label (const char *name, const char *label)
| Create a new plugin preference with name and label. More...
void | purple_plugin_pref_destroy (PurplePluginPref *pref)
| Destroy a plugin preference. More...
void | purple_plugin_pref_set_name (PurplePluginPref *pref, const char *name)
| Set a plugin pref name. More...
const char * | purple_plugin_pref_get_name (PurplePluginPref *pref)
| Get a plugin pref name. More...
void | purple_plugin_pref_set_label (PurplePluginPref *pref, const char *label)
| Set a plugin pref label. More...
const char * | purple_plugin_pref_get_label (PurplePluginPref *pref)
| Get a plugin pref label. More...
void | purple_plugin_pref_set_bounds (PurplePluginPref *pref, int min, int max)
| Set the bounds for an integer pref. More...
void | purple_plugin_pref_get_bounds (PurplePluginPref *pref, int *min, int *max)
| Get the bounds for an integer pref. More...
void | purple_plugin_pref_set_type (PurplePluginPref *pref, PurplePluginPrefType type)
| Set the type of a plugin pref. More...
PurplePluginPrefType | purple_plugin_pref_get_type (PurplePluginPref *pref)
| Get the type of a plugin pref. More...
void | purple_plugin_pref_add_choice (PurplePluginPref *pref, const char *label, gpointer choice)
| Set the choices for a choices plugin pref. More...
GList * | purple_plugin_pref_get_choices (PurplePluginPref *pref)
| Get the choices for a choices plugin pref. More...
void | purple_plugin_pref_set_max_length (PurplePluginPref *pref, unsigned int max_length)
| Set the max length for a string plugin pref. More...
unsigned int | purple_plugin_pref_get_max_length (PurplePluginPref *pref)
| Get the max length for a string plugin pref. More...
void | purple_plugin_pref_set_masked (PurplePluginPref *pref, gboolean mask)
| Sets the masking of a string plugin pref. More...
gboolean | purple_plugin_pref_get_masked (PurplePluginPref *pref)
| Gets the masking of a string plugin pref. More...
void | purple_plugin_pref_set_format_type (PurplePluginPref *pref, PurpleStringFormatType format)
| Sets the format type for a formattable-string plugin pref. More...
PurpleStringFormatType | purple_plugin_pref_get_format_type (PurplePluginPref *pref)
| Gets the format type of the formattable-string plugin pref. More...

## Detailed Description

Plugin Preferences API.

Definition in file pluginpref.h.

## Enumeration Type Documentation

enum PurplePluginPrefType

Enumerator
PURPLE_PLUGIN_PREF_INFO | no-value label
PURPLE_PLUGIN_PREF_STRING_FORMAT | The preference has a string value.

Definition at line 43 of file pluginpref.h.

enum PurpleStringFormatType

String format for preferences.

Enumerator
PURPLE_STRING_FORMAT_TYPE_NONE | The string is plain text.
PURPLE_STRING_FORMAT_TYPE_MULTILINE | The string can have newlines.
PURPLE_STRING_FORMAT_TYPE_HTML | The string can be in HTML.

Definition at line 36 of file pluginpref.h.

## Function Documentation

void purple_plugin_pref_add_choice | ( | PurplePluginPref * | pref,
|  | const char * | label,
|  | gpointer | choice
| ) |  |

Set the choices for a choices plugin pref.

Parameters

  pref | The plugin pref
  label | The label for the choice
  choice | A gpointer of the choice

void purple_plugin_pref_destroy | ( | PurplePluginPref * | pref | ) |

Destroy a plugin preference.

Parameters

  pref | The preference to destroy

void purple_plugin_pref_frame_add | ( | PurplePluginPrefFrame * | frame,
|  | PurplePluginPref * | pref
| ) |  |

Adds a plugin preference to a plugin preference frame.

Parameters

  frame | The plugin frame to add the preference to
  pref | The preference to add to the frame

void purple_plugin_pref_frame_destroy | ( | PurplePluginPrefFrame * | frame | ) |

Destroy a plugin preference frame.

Parameters

  frame | The plugin frame to destroy

GList* purple_plugin_pref_frame_get_prefs | ( | PurplePluginPrefFrame * | frame | ) |

Get the plugin preferences from a plugin preference frame.

Parameters

  frame | The plugin frame to get the plugin preferences from

Note
  The return value of this function must not be modified or freed.

Returns
  a GList of plugin preferences

PurplePluginPrefFrame* purple_plugin_pref_frame_new | ( | void |  | ) |

Create a new plugin preference frame.

Returns
  a new PurplePluginPrefFrame

void purple_plugin_pref_get_bounds | ( | PurplePluginPref * | pref,
|  | int * | min,
|  | int * | max
| ) |  |

Get the bounds for an integer pref.

Parameters

  pref | The plugin pref
  min | The min value
  max | The max value

GList* purple_plugin_pref_get_choices | ( | PurplePluginPref * | pref | ) |

Get the choices for a choices plugin pref.

Parameters

  pref | The plugin pref

Note
  The return value of this function must not be modified or freed.

Returns
  GList of the choices

PurpleStringFormatType purple_plugin_pref_get_format_type | ( | PurplePluginPref * | pref | ) |

Gets the format type of the formattable-string plugin pref.

Parameters

  pref | The plugin pref

Returns
  The format of the pref

const char* purple_plugin_pref_get_label | ( | PurplePluginPref * | pref | ) |

Get a plugin pref label.

Parameters

  pref | The plugin pref

Returns
  The label for the plugin pref

gboolean purple_plugin_pref_get_masked | ( | PurplePluginPref * | pref | ) |

Gets the masking of a string plugin pref.

Parameters

  pref | The plugin pref

Returns
  The masking

unsigned int purple_plugin_pref_get_max_length | ( | PurplePluginPref * | pref | ) |

Get the max length for a string plugin pref.

Parameters

  pref | The plugin pref

Returns
  the max length

const char* purple_plugin_pref_get_name | ( | PurplePluginPref * | pref | ) |

Get a plugin pref name.

Parameters

  pref | The plugin pref

Returns
  The name of the pref

PurplePluginPrefType purple_plugin_pref_get_type | ( | PurplePluginPref * | pref | ) |

Get the type of a plugin pref.

Parameters

  pref | The plugin pref

Returns
  The type

PurplePluginPref* purple_plugin_pref_new | ( | void |  | ) |

Create a new plugin preference.

Returns
  a new PurplePluginPref

PurplePluginPref* purple_plugin_pref_new_with_label | ( | const char * | label | ) |

Create a new plugin preference with label.

Parameters

  label | The label to be displayed

Returns
  a new PurplePluginPref

PurplePluginPref* purple_plugin_pref_new_with_name | ( | const char * | name | ) |

Create a new plugin preference with name.

Parameters

  name | The name of the pref

Returns
  a new PurplePluginPref

PurplePluginPref* purple_plugin_pref_new_with_name_and_label | ( | const char * | name,
|  | const char * | label
| ) |  |

Create a new plugin preference with name and label.

Parameters

  name | The name of the pref
  label | The label to be displayed

Returns
  a new PurplePluginPref

void purple_plugin_pref_set_bounds | ( | PurplePluginPref * | pref,
|  | int | min,
|  | int | max
| ) |  |

Set the bounds for an integer pref.

Parameters

  pref | The plugin pref
  min | The min value
  max | The max value

void purple_plugin_pref_set_format_type | ( | PurplePluginPref * | pref,
|  | PurpleStringFormatType | format
| ) |  |

Sets the format type for a formattable-string plugin pref.

You need to set the pref type to PURPLE_PLUGIN_PREF_STRING_FORMAT first before setting the format.

Parameters

  pref | The plugin pref
  format | The format of the string

void purple_plugin_pref_set_label | ( | PurplePluginPref * | pref,
|  | const char * | label
| ) |  |

Set a plugin pref label.

Parameters

  pref | The plugin pref
  label | The label for the plugin pref

void purple_plugin_pref_set_masked | ( | PurplePluginPref * | pref,
|  | gboolean | mask
| ) |  |

Sets the masking of a string plugin pref.

Parameters

  pref | The plugin pref
  mask | The value to set

void purple_plugin_pref_set_max_length | ( | PurplePluginPref * | pref,
|  | unsigned int | max_length
| ) |  |

Set the max length for a string plugin pref.

Parameters

  pref | The plugin pref
  max_length | The max length of the string

void purple_plugin_pref_set_name | ( | PurplePluginPref * | pref,
|  | const char * | name
| ) |  |

Set a plugin pref name.

Parameters

  pref | The plugin pref
  name | The name of the pref

void purple_plugin_pref_set_type | ( | PurplePluginPref * | pref,
|  | PurplePluginPrefType | type
| ) |  |

Set the type of a plugin pref.

Parameters

  pref | The plugin pref
  type | The type